#/usr/bin/perl -w
###############################################################################
# Perl-skripti harjoitustyon ottamiseksi WWW:sta tai laittamiseksi sinne
#
# Kutsun syntaksi:
#   lue.pl KOMENTO ohjetiedosto kone kayttaja kurssi [comps-hakemisto] [passwd]
#
#   Esim:
#
#   perl lue.pl GET files.txt www.jyu.fi vesal gko 
#     - hakee ensin tiedoston http://www.jyu.fi/~vesal/gko/files.txt
#	ja sitten sen ohjeiden mukaan tekee paikalliselle levylle
#	tarvittavat alihakemistot ja hakee sitten tarvittavat tiedostot
#	Jos koneen nimen perss on polku, niin mitn ei list
#	Eli esim:
#   perl lue.pl GET files.txt www.it.jyu.fi/users/vesal/gko 
#     - hakee ensin tiedoston 
#	http://www.it.jyu.fi/users/vesal/gko/files.txt
#	ja sitten sen ohjeiden mukaan tekee paikalliselle levylle
#	tarvittavat alihakemistot ja hakee sitten tarvittavat tiedostot
#   perl lue.pl FTP files.txt www.jyu.fi vesal gko
#     - lukee paikallisen levyn oletushakemistosta tiedoston
#	files.txt ja sen ohjeiden mukaan kopioi paikalliselta levylta
#	ftp:lla tiedostoja www.jyu.fi-koneessa kyttjn vesal kotihakemisto 
#	ja sen alla www/gko hakemistoon luoden tarvittaessa uusia
#	hakemistoja
#	Tekee lisksi saman kuin HTML
#   perl lue.pl HTML files.txt tukki vesal gko
#     - lukee paikallisen levyn oletushakemistosta tiedoston
#	files.txt ja tekee siit tiedostot files.html ja index.html, jotka 
#	kopioidaan ftp:lla tukki-koneeseen kyttjn vesal kotihakemistoon
#	hakemistoon www/gko.
#   perl lue.pl HTML files.txt tukki vesal gko comps -
#     - lukee paikallisen levyn oletushakemistosta tiedoston
#	files.txt ja tekee siit tiedostot files.html ja index.html, joita
#	ei kopioida mihinkn muualle, sill salasanana on -
#     
#   perl lue.pl PUREHTML files.txt tukki vesal gko
#     - lukee paikallisen levyn oletushakemistosta tiedoston
#	files.txt ja tekee siit tiedostot files.html ja index.html, joita
#	ei kopioida mihinkn muualle
#     
#   perl lue.pl COPY files.txt w: vesal gko
#     - lukee paikallisen levyn oletushakemistosta tiedoston
#	files.txt ja tekee siit tiedostot files.html ja index.html, ja
#	kopioi ne paikkaa w:\gko
#     
#
# Tiedoston files.txt muoto on yksinkertaisimmillaan:
#    oma/tiedosto.c   = kommentti
#    oma/ali/ali.c    = kommentti 2
#
# Tahan voidaan lisata myos koristeita, 
#  =-	     => WWW-sivulle <hr>, eli viiva 
#  =Otsikko  => WWW-sivulle Pelkastaan teksti Otsikko
#
#    =------------------------------
#    =Otsikko
#    =------------------------------
#    oma/tiedosto.c   = kommentti
#    oma/ali/ali.c    = kommentti 2
#    =------------------------------
#
# Jos projektiin tarvitaan esim. muiden tekemia komponentteja, niin
# nehan tietysti luetaan aivan jostakin muusta paikasta ja niita
# ei kirjoiteta FTP-komennossa takaisin (ei me pilata muiden tekemia).
# Talloin files.txt voisi olla esimerkiksi:
#
#    =--------------------
#    =Delphi ty
#    =--------------------
#    delphi/vespacad.dpr    = projektitiedosto VespaCadia varten
#    delphi/vespacadf.dfm   = plomake
#    delphi/vespacadf.pas   = lhdekoodi 
#    =--------------------
#    =Muut tarvittavat komponentit
#    =--------------------
#    $DESTINATION=$COMPS
#    $SOURCEPATH=http://www.mit.jyu.fi/~vesal/kurssit/winohj/winohj/delphi/comps/editpnl/
#    savepos.pas = komponentti paikan tallettamiseksi
#    SavePos.dcr = komponentin kuvake
#
# Selityksia files.txt -tiedostosta
#   tiedoston nimi= suhteellinen nimi nykyiseen $SOURCEPATH-muuttujaan
#		    ja paikallisen levyn hakemistoon verrattuna.
#		    Oletuksena $SOURCEPATH riippuu konetorivin parametreista. 
#		    Eli esimerkissa luetaan
#		    (komento: GET, tiedosto: delphi/vespacadf.pas)
#		      http://www.jyu.fi/~vesal/gko/delphi/vespacadf.pas
#		    -tiedosto, luodaan paikalliselle levylle delphi
#		    niminen alihakemisto ja kopioidaan tiedosto sinne.
#		    Vastaavasti FTP-komennolla otetaan paikallisen levyn
#		    tiedosto delphi/vespacadf.pas ja kirjoitetaan se
#		    www.jyu.fi-koneessa kayttajan vesal kotihakemistosta
#		    alkaen tiedostoksi www/gko/delphi/vespacad.pas
#		    
#   $DESTINATION  = paikallisen levyn hakemisto, jonne tiedosto laitetaan
#		    Apumuuttuja $COMPS on komentorivilta annetun 
#		    comps-hakemiston arvo (pitaa sisaltaa /-merkki lopussa).  
#		    Oletuksena comps-hakemisto on ../comps/		   
#   $SOURCEPATH   = www-polku, joka lisataan seuraavien tiedostojen nimien
#		    eteen kun tiedostoa haetaan WWW:sta.  
#		    Oletuksena tama on tyhja.  Ja jos kirjoitetaan
#		    $SOURCEPATH =, palataan kayttamaan alkuperaista hakemistoa
#		    joka maaraytyy komentorivin parametreista 
#		    Ne tiedostot, joiden aikana $SOURCEPATH on epatyhja, ovat
#		    ReadOnly-tiedostoja, eli niita ei kopioda FTP-komennolla
#		    takaisin verkkoon.	$SOURCEPATH ja $DESTINATION voidaan
#		    muuttaa kuinka monta kertaa tahansa, ja ne vaikuttavat
#		    seuraavaan muutokseen saakka.   
#		      
# Kayttovinkkeja:
# ================
#
# A. Aloitus ja tallettaminen
# ----------------------------
#  1) kirjoita paikalliselle levylle tiedosto files.txt
#  2a)anna komento:
#	perl lue.pl FTP files.txt www.jyu.fi vesal gko
#     (Tietenkin korvaten www.jyu.fi, vesal ja gko vastaavilla koneen nimella,
#     omalla tunnuksellasi ko. koneessa ja kurssin nimella).
#  2b)anna komento
#	perl lue.pl COPY files.txt w: vesal gko
#  3) Nain sinulle syntyy www.jyu.fi-koneeseen hakemisto www/gko ja sen alle
#     tarvittavat alihakemistot.  Hakemistoon gko tulee tiedostot
#     files.html ja index.html, joilla tiedostojasi voi selata kivasti.
#  4) Kun jatkossa lisaat uusia tiedostoja projektiisi tai paivitat
#     vanhoja, niin tarpeen mukaan muutat paikallisessa koneessa 
#     (siis kayttamassasi mikrossa) tiedostoa files.txt tarpeen mukaan.
#     Sitten annat aina kohdassa 2) mainitun komennon
#
# B. Tyon jatkaminen toisessa koneessa
# ------------------------------------ 
#  1) siirry paikallisessa koneessa omaan hakemistoosi, esim
#	d:\omat\vesal\gko
#  2a)anna komentorivilta komento
#	perl lue.pl GET files.txt www.jyu.fi vesal gko 
#     (Tietenkin taas korvaten nimet vastaavilla)
#  2b)anna komentorivilta komento
#	perl lue.pl GET files.txt www.infotec.jyu.fi/users/vesal/gko 
#     (Tietenkin taas korvaten nimet vastaavilla)
#  3) Jatkat ohjelmointia ja lopettaessasi annat komennon kohdasta A.2)
#
# C. Helpottaminen
# ----------------
#  1) Jos osaat yhtaan kirjoittaa DOS-komentoja  .bat -tiedostoon, niin
#     kirjoitat itsellesi komento ht.bat:
#	lue.pl %1 files.txt www.jyu.fi vesal gko 
#  2) Lukeminen:
#	ht GET
#  3) Tallettaminen:
#	ht FTP 
#
# D. Harjoitustyon nayttaminen
# -----------------------------
#  1) Kun saavut nayttamaan harjoitustyotasi kerro ohjaajalle
#      a) tunnuksesi (esim. vesal)
#      b) koneen nimi (esim. www.jyu.fi)
#      c) kurssin tunnus (esim. gko)
#
# Vesa Lappalainen
#  26.5.1999
#   5.8.1999
# 26.10.1999
#  + luodaan kurssihakemisto www-koneeseenkin jos se puuttuu
# 30.10.1999
#  + vaihdettu kyttmn vlftplib.pl, koska alkup. ftplib.pl ei
#    osannut binrist siirtoa :-(
# 27.12.1999
#  + salasana - katkaisee lopun skriptin suorituksen
# 19.11.2000
#  + COPY - komento
#  + PUREHTML -komento
#  + GET-komentoon / tulkinta estmn polun muokkaus
#  + Tuotettu HTML paremmin kelpaamaan validaattorille
#  + hakemisotn nimen pakkomuuttaminen pieneksi poistettu =>
#    PIT olla huolellinen hakemistojen nimi kirjoitettaessa
#		     
# 27.12.2000
#  + COPY luo kaikki tarvittavat kohdepolussa olevat hakemistot  
#
# 20.1.2001
#  + tulostetaan <br>:i kommenttirivien pern
#  + tarkistetaan paremmin milloin listn http: ja milloin ei
#
# 27.1.2001
#  + muuttaa vlilynnilliset tiedoston nimet linkeiss muotoon %20
#    mys % muuteteen %25
#  + tekee mys FTP:ll tarvittavat alihakemistot ennen siirtoa 	     
#
###############################################################################
# require('vlftplib.pl');  # siirretty vain niihin kohti, joissa tarvitaan

use strict;

###############################################################################
sub trim($) { # merkkijono => merkkijono
  my($s) = @_;
# Poistetaan merkkijonosta alkutyhjat, lopputyhjat ja rivinvaihdot (lopusta)
# Esim. "   kissa istuu\n   "  => "kissa istuu"
  $s =~ s/^\s*//;      # alkutyhjat
  $s =~ s/\s*$//;      # lopputyhjat (mys rivinvaihdot)
# s/^\s*(.*?)\s*$/\1/;
  return $s;
}

###############################################################################
sub ToHtmlName($) { # merkkijono => merkkijono
  my($s) = @_;
# Poistetaan merkkijonosta alkutyhjat, lopputyhjat ja rivinvaihdot (lopusta)
# Esim. "   kissa istuu\n   "  => "kissa istuu"
  $s =~ s/%/%25/g;	# vlilynnit
  $s =~ s/ /%20/g;	# vlilynnit
  return $s;
}

###############################################################################
sub CheckHTTP($) { # merkkijono => merkkijono
  my($s) = @_;
# Jos jonossa ei ole http://, niin se listn
# Samoin loppu / jos se puuttuu
# Esim. "www.mit.jyu.fi/~vesal"  => "http://www.mit.jyu.fi/~vesal/"
# Tyhjst jonosta palautetaan tyhj jono
#
  if ( $s eq "" ) { return $s; }
  if ( !( $s =~ /\/$/ ) ) { $s = "$s/"; }
  if ( !( $s =~ /^http:/ ) ) { 
    if ( !( $s =~ /^\// ) ) { $s = "/$s"; }
    if ( !( $s =~ /^\/\// ) ) { $s = "/$s"; }
    $s = "http:$s"; 
  }
  return $s;
}

use Time::localtime;
use File::stat;

###############################################################################
sub GetWWWFileDate($) # => mtime
#------------------------------------------------------------------------------
# Hakee WWW-tiedoston pivyksen
# Esim: GetWWWFileDate('http://www.jyu.fi/~vesal/gko/delphi/vespacadf.dfm')
###############################################################################
{
  my ($url) = @_;
  $url	= ToHtmlName(trim($url));


  require LWP;
  # Create the user agent object
  my $ua =new LWP::UserAgent;

  # Set up a request.  We will use the same request object for all URLs.
  my $request = new HTTP::Request "GET";

  # Send the request and get a response back from the server
  $request->url($url);
  my $response = $ua->request($request);

  if ($response->is_success) {
    $response->headers->last_modified;
  } else {
    0;
  }

}

#open(VSTDERR,">c:\\temp\\error.txt");

###############################################################################
sub GetWWWFile($$) {  
  my ($url,$file) = map {trim($_)} @_;
  $url	= ToHtmlName($url);
#  $file = trim($file);
#------------------------------------------------------------------------------
# Hakee WWW-tiedoston ja tallettaa sen lokaalisti valituksi tiedostoksi
# Esim: GetWWWFile('http://www.jyu.fi/~vesal/gko/delphi/vespacadf.dfm',
#		   'delphi/vespacadf.dfm');
# Mahdollisesti tarvittavat alihakemistot pit jo olla olemassa
# Otetaan vain tiedostot, jotka ovat uudempia kuin kohdekoneessa
###############################################################################
  my $filedate = 0;
  my $filestat;
  $filestat = stat($file) and $filedate = $filestat->mtime; 
# my $filedate = $filestat->mtime if $filestat = stat($file);
  require LWP;
  # Create the user agent object
  my $ua =new LWP::UserAgent;

  # Set up a request.  We will use the same request object for all URLs.
  my $request = new HTTP::Request "GET";

  # Send the request and get a response back from the server
  $request->url($url);
  my $response = $ua->request($request);

  if ($response->is_success) {
    if ( $response->headers->last_modified > $filedate ) {
      print "$url => $file\n";
      # print ctime($response->headers->last_modified) . " " . ctime($filedate) . "\n"; 
      # print $response->headers->last_modified . " $filedate"\n"; 
      open(OUT, ">$file") or die "Error opening output file $file: $!\n"; 
      binmode OUT;
      print OUT $response->content;
      close(OUT) if ($file);
      utime $response->headers->last_modified,$response->headers->last_modified,$file;
    } 
    # else { print ctime($response->headers->last_modified) . " " . ctime($filedate) . "\n"; } 
    # else { print "@{[ctime($response->headers->last_modified) ctime($filedate)\n"; } 
    # else { print "$response->headers->last_modified";
  } else {
    print STDERR "ERROR: $url\n"; 
    print STDERR $response->error_as_HTML;
  }

}

###############################################################################
sub CopyFileIfNewer($$) {  
  my ($source,$dest) = map {trim($_)} @_;
#  $url  = trim($url);
#  $file = trim($file);
#------------------------------------------------------------------------------
# Kopioi lokaalin tiedoston toiselle levylle
# Esim: CopyFileIfNewer('delphi/vespacadf.dfm','w:/gko/delphi/vespacadf.dfm');
# Mahdollisesti tarvittavat alihakemistot pit jo olla olemassa
# Kopioidaan vain tiedostot, jotka ovat uudempia kuin kohdekoneessa
###############################################################################
use File::Copy;
  my $destdate = 0;
  my $deststat;
  my $sourcedate = 0;
  my $sourcestat;
  $deststat = stat($dest) and $destdate = $deststat->mtime; 
  $sourcestat = stat($source) and $sourcedate = $sourcestat->mtime; 


    if ( $sourcedate > $destdate ) {
      print "$source => $dest";
      if ( !copy($source,$dest) ) { print " Error: $!"; }
      print "\n";  
    } 
    # else { print ctime($response->headers->last_modified) . " " . ctime($filedate) . "\n"; } 
    # else { print "@{[ctime($response->headers->last_modified) ctime($filedate)\n"; } 
    # else { print "$response->headers->last_modified";
}

###############################################################################
sub hakemisto_lista($$) { # $hakemisto,\%hakemistot
#------------------------------------------------------------------------------
# Lis %hakemistot-listaan kaikki hakemiston alihakemistot joita ei viel ole
# listassa.
# Esim: $hakemisto = "oma1/oma2"  => listn ("oma1","oma1/oma2")
###############################################################################
  my ($hakemisto,$hakemistot) = @_;
  my $loput = $hakemisto;
  my $alku = "";
  my $hak;
  while ( 1 ) {
    ($hak,$loput) = split("[/\\x5c]",$loput,2);
#    print "$hak $loput \n";
    if ( not $loput ) { last; }
    if ( not $hak ) { next; }
    $alku .= $hak;
    $$hakemistot{($alku)} = "";  
#    $$hakemistot{lc($alku)} = "";  
    $alku .= "/";
  }
}

# @dirs = split "/", lc $hakemisto;
# for(0..$#dirs) {$hakemistot->{join '/', @dirs[0..$_]} = ""}


###############################################################################
sub ShowFtpError() {
###############################################################################
#  my $error = ftp::error();
#  if ( $error ) { print "FTP error: $error\n"; }
}


###############################################################################
# Pohjelma
###############################################################################
my $command  = $ARGV[0];
my $filename = $ARGV[1];
my $www      = $ARGV[2];
my $user     = $ARGV[3];
#my $kurssi   = $ARGV[4];
my ($kurssi,$foo) = split("[/\\x5c]",$ARGV[4],2);
my $comps    = $ARGV[5];
my $passwd   = $ARGV[6];
my $mainpath = $ARGV[2];
my $subpath  = $ARGV[4]; 
$subpath =~ s!/*$!!;			  # delete extra / end of subpath
$www =~ s!/*$!!;			  # delete extra / end of www-machine 
my $defwww   = "$www/~$user/$subpath";

if ( $www =~ /\// ) { $defwww = $www; }  # if / in www then this is the
					 # total path


if ( $comps lt "	   " ) {  $comps = '../comps/'; }  # as default

my $sourcepath	= "";
my $destination = "";

$defwww = CheckHTTP("$defwww");

if ( $command eq "GET" ) {
  GetWWWFile("$defwww$filename","$filename");
}

#print "Args: 0:$command 1:$filename 2:$www 3:$user 4:$kurssi 5:$comps 6:$passwd 7:$mainpath $subpath 8:$defwww\n";

open(TIEDOSTOT,$filename) or die("File not found: $filename!\n");

my @tiedostot  = ();
my @alkuosat   = ();
my @kommentit  = ();
my @lahdepolut = ();
my @lahteet    = ();
my @kohdepolut = ();
my %hakemistot = ();  # Kytetn vain hashin avainosaa :-)

while (my $rivi=<TIEDOSTOT>) {
  my ($alkuosa, $kommentti) = split("=",$rivi,2);
  $alkuosa = trim($alkuosa);
  if ( $alkuosa eq '$SOURCEPATH' )  { $sourcepath  = trim($kommentti); next; } 
  if ( $alkuosa eq '$DESTINATION' ) { 
    $destination = trim($kommentti); 
    if ( $destination eq '$COMPS' ) { $destination = $comps; }
    next; 
  } 

  push @alkuosat, ($alkuosa);
  push @kommentit,(trim($kommentti));
  push @lahteet,($sourcepath); 

  if ( $alkuosa ge "	   " ) {
    push @lahdepolut,($sourcepath);
    push @kohdepolut,($destination);
    push @tiedostot, ($alkuosa);
    hakemisto_lista("$destination$alkuosa",\%hakemistot);
  }
}
close(TIEDOSTOT);

my @lajiteltu = sort(keys(%hakemistot));


###############################################################################
sub MakeHtmlFiles() {
###############################################################################
  open(OUT, ">index.html") || die "Error opening output file index.html: $!\n";
  print OUT <<"__STOP__";
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN">
<html>
<head>
<title>$user/$kurssi/</title>
</head>
<frameset cols=\"33%,66%\">
<frame src=\"files.html\" NAME=m1>
<frame src=\"$tiedostot[0]\" NAME=m2>
<noframes>
<body>
<h1>$kurssi/$user</h1>
</body>
</noframes>
</frameset>
</html>
__STOP__
  close OUT;

  open(OUT, ">files.html") || die "Error opening output file files.html: $!\n";
  print OUT <<"__STOP__";
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<base target=m2>
<title>$user/$kurssi</title>
</head>
<body>
<h1>$kurssi/$user</h1>
__STOP__

  for (my $i=0; $i < @alkuosat; $i++ ) {
    if ( $alkuosat[$i] ge "	  " ) {
      my $htmlfile = ToHtmlName("$lahteet[$i]$alkuosat[$i]");
      print OUT "<a href=\"$htmlfile\">$alkuosat[$i]</a> = $kommentit[$i]<br>\n";
#      print OUT qq{<a href="$lahteet[$i]$alkuosat[$i]">$alkuosat[$i]</a> = $kommentit[$i]<br>\n};
    } else {
      if ( "-" le $kommentit[$i] && $kommentit[$i] lt "-A" ) { print OUT "<hr>\n"; }
      elsif ( $kommentit[$i] ge "	    " )    {
	print OUT "$kommentit[$i]";
	if ( ! ( $kommentit[$i] =~ /<.*>/ ) ) { print OUT "<br>"; }
	print OUT "\n";
      }
      else					   { print OUT "<br>";		   }
    }
  }

  print OUT "</body>\n";
  print OUT "</html>\n";
  close OUT;
}


###############################################################################
if ( $command eq "GET" ) {
  foreach my $hak (@lajiteltu) {
    mkdir $hak,0;
    print "mkdir $hak\n";
  }

# for my $i (0..$#tiedostot) { 
  for (my $i=0; $i < @tiedostot; $i++ ) {
    my $tied = $tiedostot[$i];
    my $lahde = $lahdepolut[$i];
    my $kohde = $kohdepolut[$i];
    if ( $lahde eq "" ) { $lahde = CheckHTTP($defwww); }
#   my $lahde = ($lahdepolut[$i] || CheckHTTP("$www/~$user/$kurssi");
    GetWWWFile("$lahde$tied","$kohde$tied");
  }
}

###############################################################################
if ( $command eq "PUREHTML" ) {
  MakeHtmlFiles();
}

###############################################################################
if ( $command eq "HTML" || $command eq "FTP" ) {
  require('vlftplib.pl');
  MakeHtmlFiles();


  my $host = $www;
  $host =~ s!.*//!!;	      # Mahdollinen http:// pois 
  $host =~ s!/.*!!;	      # Kaikki /-jlkeiset osat pois
  if ( $passwd eq "" ) {
    print "Password for $host.$user >";
    $passwd = <STDIN>;
    if ( $passwd eq "" ) { die "No passwd"; }
    $passwd =~ s/\n//;
  } 

  if ( $passwd eq "-" ) { die "No ftp"; }

  ftp::debug('ON');
  ftp::open($host, $user, $passwd) or die("Can not open ftp $host, $user");
			       ShowFtpError;
  ftp::binary();	      
  my %polun_palat = ();  # Kytetn vain hashin avainosaa :-)
  hakemisto_lista("$subpath/.",\%polun_palat);
  my @spolun_palat = sort(keys(%polun_palat));	

#  print %polun_palat; print "\n";
#  print @spolun_palat; print "\n";

  ftp::cwd("www");     ShowFtpError;
  foreach my $hak (@spolun_palat) {
    ftp::mkdir("$hak");   ShowFtpError;
#   ftp::cwd("$hak");	ShowFtpError;
    print "mkdir $hak\n";
  }
#  ftp::mkdir("www/$subpath");	 ShowFtpError;
   ftp::cwd("$subpath");     ShowFtpError;
 
  ftp::put("files.html","files.html");	    ShowFtpError;
  ftp::put("index.html","index.html");	    ShowFtpError;
#  my @dir = ftp::dir(".");
#  print "---------\n";
#  print $dir[0];
#  print "---------\n";

###############################################################################
if ( $command eq "FTP" ) {
  require('vlftplib.pl');

  foreach my $hak (@lajiteltu) {
    print "mkdir $hak\n";
    ftp::mkdir($hak);	       ShowFtpError;
  }

  ftp::put("files.txt","files.txt");  ShowFtpError;

#  foreach my $tied (@tiedostot) {
  for (my $i=0; $i < @tiedostot; $i++ ) {
    my $tied = trim($tiedostot[$i]);
    if ( $lahdepolut[$i] gt "	" ) { next; }

    my $lahde = $lahdepolut[$i];
#    if ( $lahde eq "" ) { $lahde = CheckHTTP("$www/~$user/$subpath"); }
    if ( $lahde eq "" ) { $lahde = CheckHTTP("$defwww"); }
#    print "$lahde$tied\n";
    my $mtime = GetWWWFileDate("$lahde$tied");

    my $filedate = 0;
    my $filestat;
    $filestat = stat($tied) and $filedate = $filestat->mtime; 
    print "$tied: " . ctime($filedate) . " - " . ctime($mtime) ;

    if ( $filedate > $mtime ) { 
      ftp::put($tied,$tied);   ShowFtpError;
      print "->";
    }
    print "\n";
  }
}

  ftp::close(); 
} 
###############################################################################

###############################################################################
if ( $command eq "COPY" ) {
  MakeHtmlFiles();
  my $destpath = "$mainpath/$subpath";

  my %polun_palat = ();  # Kytetn vain hashin avainosaa :-)
  hakemisto_lista("$subpath/.",\%polun_palat);
  my @spolun_palat = sort(keys(%polun_palat));	

#  print %polun_palat; print "\n";
#  print @spolun_palat; print "\n";

  foreach my $hak (@spolun_palat) {
    mkdir "$mainpath/$hak",0;
    print "mkdir $mainpath/$hak\n";
  }
#  print "mkdir $destpath\n";
#  mkdir "$destpath",0;

  foreach my $hak (@lajiteltu) {
    print "mkdir $destpath/$hak\n";
    mkdir "$destpath/$hak",0;
  }

  CopyFileIfNewer("files.txt","$destpath/files.txt");
  CopyFileIfNewer("files.html","$destpath/files.html");
  CopyFileIfNewer("index.html","$destpath/index.html");

#  foreach my $tied (@tiedostot) {
  for (my $i=0; $i < @tiedostot; $i++ ) {
    my $tied = trim($tiedostot[$i]);
    if ( $lahdepolut[$i] gt "	" ) { next; }

    CopyFileIfNewer($tied,"$destpath/$tied");
  }
} 
###############################################################################

###############################################################################

